;;  Dynamic block field update to elevation based on the y-axis

;;;-----------------------------------------------------------------------
;;; Makro     : AF2LB (Attach field to Level block)
;;; Version   :	v1.0 
;;; Date      : 23.02.2006
;;; Version   : AutoCAD 2006 / 2007
;;; Author    : Muharrem Kocyigit
;;; Modified  : by CAB 02.18.2009 Changed to UCS ILO WCS & stripped Formatting
;;; Modified  : Hans Lammerts for Royal Haskoning 25.02.2009
;;;		Changed to meters
;;;		Choose UCS
;;;		Draws line fot choosen UCS (function grdraw)
;;;		Function DNHm for meter (divided by 1.0)
;;;-----------------------------------------------------------------------
(setq glv:BlkName '( "Dyn-LEVEL-TR" "Dyn-LEVEL-TR2" "Dyn-LEVEL-TR3" ))		;more blocks
(setq glv:BlkATAG "LEVEL"       )
;;;-----------------------------------------------------------------------

; ALGEMEEN INLADEN SYMBOOL


(defun predef_layer_style_dnh (/ txttekst)
  
(setq getDDSvalue (getvar "cannoscalevalue"))
(setq getinsunits (getvar "insunits"))
(setq svalue1 (/ 1 getDDSvalue))
(if (= getinsunits 6) (setq svalue2 (* svalue1 1000))  ; voor meter
(if (= getinsunits 4) (setq svalue2 (* svalue1 1)) (setq svalue2 svalue1)) ; voor millimeter en overige
)
(if (= getinsunits 6) (setq eenheid "m")  ; voor meter
(if (= getinsunits 4) (setq eenheid "mm") (setq eenheid "--")) ; voor millimeter en overige
)
(setq svalue_str (rtos svalue2 2 0))
(setq schaaltekst (strcat "1-" svalue_str))
  (setq oldlayer (getvar "clayer"))
  (setvar "cmdecho" 0)
  (setq txtstyletekst (getvar "textstyle"))
  (setq mofmmtekst (getvar "users5")) 
  (setq getDDS (getvar "cannoscale"))
  (setq getDimstyle (getvar "dimstyle"))
  (setq txttekst (strcat "X_dim_DNH_" eenheid)) ; getDimstyle "_" eruit, werkt niet lekker..
  (setvar "users2" txttekst)
  (prompt "\n")
  (prompt txttekst)
  )


(defun c:inladenblock ()

  (setq ss (ssget "X" '((2 . "dyn-level-tr"))))
   (if (= ss nil)
    (progn
      (command "-insert" "dyn-level.dwg" "0,0" "1" "1" "0")  		; maatvoeringsstyle inladen (in geheugen)
      (setq ss (ssget "X" '((2 . "dyn-level"))))
      (command "erase" ss "")) ())

  (setq ss2 (ssget "X" '((2 . "dyn-XYZ"))))
   (if (= ss2 nil)
    (progn
      (command "-insert" "dyn-xyz-file.dwg" "0,0" "1" "1" "0")  		; maatvoeringsstyle inladen (in geheugen)
      (setq ss2 (ssget "X" '((2 . "dyn-xyz-file"))))
      (command "erase" ss2 "")) ())
  
 (setq oldlayer (getvar "clayer"))
  (initget "y n")
  (setq blkflg (getkword "\nInsert blockdefenitie? Y/N <N>: "))
  (if (= blkflg "y")
    (progn
      (Prompt "\nInserting block Dyn-LEVEL-TR .. ")
      (Setq pt1 (GetPoint "\nInsertion maatvoering: "))
     ; (setq annoscale (getvar "cannoscalevalue"))
     ; (setq annoscale (/ 1 cannoscale))
      (predef_layer_style_dnh)
      (setq txttekst (getvar "users2"))
      (setq searchlayer (tblsearch "layer" txttekst))  
      
      
      (command "insert" "dyn-level-tr" pt1 "" 1 0 "" "")
     
     (command "regen") 
    ) 
  ()
  ) ; end if
  ) ; end defun

;--------------------------

(defun C:DNH ()
 (c:inladenblock)
  (setq getunits (getvar "insunits"))
  (if (= getunits 4) (C:DNHmm) (C:DNHm)))

(defun c:DNHmm (/ sel e obj InsPt objAttribut ObjID FStr YVal PrFix ss n k
                 len x str ObjAttList lstDynProp DynID DynVal PtIndex ValOfPt)
  (vl-load-com)
  ;(COMMAND "REGEN")
 ;(prompt "\nDynamic height - Select Blocks to update Elevations.")
    
  
  (setq pt1 '(-10000000.0 0.0 0.0))
  (setq pt2 '(10000000.0 0.0 0.0))
  (grdraw pt1 pt2 6 1)
  (setq getucs (getvar "ucsname"))
  (if  (= getucs "") (setq getucs "*Not Named*") ())
  (SETQ PEIL (GETPOINT (strcat "\nNamed UCS: " getucs "\nEnter or give point for elavation 0.0: ")))
  (command "ucs" PEIL "")
  (COMMAND "Redraw")
  (setq pt1 '(-10000000.0 0.0 0.0))
  (setq pt2 '(10000000.0 0.0 0.0))
  (grdraw pt1 pt2 6 1)

  (SETQ STOP 1)
  (WHILE (/= STOP 0)
  (if (setq ss (ssget)) 
    (progn
      (setq n  0 )
      (while (< n (sslength ss))

        (setq e   (ssname ss n))
        (setq obj (vlax-ename->vla-object e))

        (if (And (= (vla-get-ObjectName    obj) "AcDbBlockReference")
                 (= (vla-get-HasAttributes obj) :vlax-true) )

          (if    (vl-position (vla-get-EffectiveName obj) glv:BlkName) (progn		; CAB, for block ..1 ..2


            (setq ObjID (vla-get-ObjectID       obj) 
                  ;;InsPt (vla-get-InsertionPoint obj)  ; CAB
                  InsPt (trans (vlax-get Obj 'InsertionPoint) (vlax-get Obj 'Normal) 1) ; OCS 2 UCS - CAB
		  ;;InsPt  (vlax-get Obj 'InsertionPoint)  ; lamh ook voor in z voor Z(Y1) Z(Y2) Z(Y3) 
            )

            ;(setq InsPt (vlax-safearray->list (vlax-variant-value Inspt)))  ; CAB
	    
            (if (= (vla-get-IsDynamicBlock obj) :vlax-true)
              (progn
             
             ;; properties
            
            (setq lstDynProp
              (vlax-safearray->list
                (vlax-variant-value (vla-GetDynamicBlockProperties obj))
              )
            )
            (foreach x lstDynProp
              (if (member (vla-get-PropertyName x) (list "Visibility"))
                (progn
                (setq DynID  (vla-get-PropertyName x))
                (setq DynVal (vlax-variant-value (vla-get-Value x)) )
              )) ; end progn, if
            ) ; end forEach

            (cond
              ((member DynVal (list "Y1" "Y2" "Y3" "Y4"
                                    "Y5" "Y6" "Y7" "Y8" ))
                (setq ValOfPt (nth 1 InsPt) PtIndex 2)  
              )
              ((member DynVal (list "Z1" "Z2" "Z3" "Z4"))
                (setq ValOfPt (nth 2 InsPt) PtIndex 4)
	       )
	      
	      ((member DynVal (list "Z(Y1)" "Z(Y2)" "Z(Y3)"))
	        (setq  InsPt  (vlax-get Obj 'InsertionPoint)); lamh ook voor in z voor Z(Y1) Z(Y2) Z(Y3)
                (setq ValOfPt (nth 2 InsPt) PtIndex 4)
	       )
	       (T (setq ValOfPt (nth 1 InsPt) PtIndex 2))
              
              
            ) ; end cond

          )) ; end progn, if DynamicBlock

         ;;  Test Mod by CAB
	    (princ ValOfPt)
	(setq ValOfPt (/ ValOfPt 1000.))
	;   (princ "")
	    (princ ValOfPt) 
	(setq ValOfPt (rtos ValOfPt 2 3))
	;   (princ "")
	    (princ ValOfPt)
	(setq ValOfPt (atof ValOfPt))
            (princ "")
	    (princ ValOfPt)	       
        ; (setq ValOfPt (atoi (rtos (/ ValOfPt 1000.) 2 3))) ; CAB rount to zero precision @ 0.49999 = 0

          ;;; Check Y-Value or Z-Value of point

          (setq str
            (cond
              ((> ValOfPt 0.0) "+"   )
              ((= ValOfPt 0.0) "%%P" )
              ((< ValOfPt 0.0) ""    )
              (T               ""    )
            )
          )

            (setq NULPUNT '(0.0 0.0 0.0))	    
	    (grdraw NULPUNT InsPt 2 1)  ; lijntje trekken..  
            	  

          ;;; Define Praefix
;|  CAB removed
          (setq PrFix (strcat "%ps[" str ",]"))
          (setq YVal  (strcat "%<\\AcObjProp Object(%<\\_ObjId "
                              (vl-princ-to-string ObjID)
                              ">%).InsertionPoint>%"
          ))
          (setq FStr (strcat "%<\\AcExpr (" YVal "/" "1000" ") "
                             "\\f \"" "%lu2"
                             "%pt" (itoa PtIndex)
                             "%pr3" "%ds44" PrFix "\">%"
          ))
|;
	
(setq DZ (getvar "DIMZIN"))
(setvar "DIMZIN" 0)
(setq FStr  (strcat str (rtos ValOfPt 2 3)))
(setvar "DIMZIN" DZ)

          ;;; Get Attribut of Block

          (setq objAttList
            (vlax-safearray->list
              (vlax-variant-value (vla-GetAttributes obj)
            )
          ))

          (setq k 0 len (length objAttList) )

          (while (< k len )
            (if (= (vla-get-TagString (setq x (nth k objAttList)))
                   glv:BlkATAG )
             (setq objAttribut x  k len )
            )
            (setq k (1+ k))
          )

          (if objAttribut
            (progn

            (vla-put-TextString objAttribut FStr )
            (vla-update objAttribut )

             ;;; Update Field Value with command

            (SetVar "CmdEcho" 0)
            (VL-CmdF "_.UpdateField" e "")
	    (SetVar "CmdEcho" 1)

          )) ;; end progn, if
        ) ; end if
      )) ; end progn, if BLOCK + Attribut

      (setq n (1+ n))

    ) ; end while
  )) ; end progn, if
  ) ; end while  

  (princ)
  ;(COMMAND "REGEN")
)
;;;-----------------------------------------------------------------------

(princ)


;;  Dynamic block field update to elevation based on the y-axis

;;;-----------------------------------------------------------------------
;;; Makro     : AF2LB (Attach field to Level block)
;;; Version   :	v1.0 
;;; Date      : 23.02.2006
;;; Version   : AutoCAD 2006 / 2007
;;; Author    : Muharrem Kocyigit
;;; Modified  : by CAB 02.18.2009 Changed to UCS ILO WCS & stripped Formatting
;;; Modified  : Hans Lammerts for Royal Haskoning 25.02.2009
;;;		Changed to meters
;;;		Choose UCS
;;;		Draws line fot choosen UCS (function grdraw)
;;;		Function DNHm for meter (divided by 1.0)
;;;-----------------------------------------------------------------------
(setq glv:BlkName '( "Dyn-LEVEL-TR" "Dyn-LEVEL-TR2" "Dyn-LEVEL-TR3" ))		;more blocks
(setq glv:BlkATAG "LEVEL"       )
;;;-----------------------------------------------------------------------
(defun c:DNHm (/ sel e obj InsPt objAttribut ObjID FStr YVal PrFix ss n k
                 len x str ObjAttList lstDynProp DynID DynVal PtIndex ValOfPt)
  (vl-load-com)
  ;(COMMAND "REGEN")
  ;(command "insert" "dyn-level.dwg" pt1 "1" "1" "" "" "" "" "")
  ;(prompt "\nDynamic height - Select Blocks to update Elevations.")
  ;(prompt "\n.... block inserted in DWG - Insert block Dyn-level-tr or update block ....")
  

  (setq pt1 '(-10000000.0 0.0 0.0))
  (setq pt2 '(10000000.0 0.0 0.0))
  (grdraw pt1 pt2 6 1)
  (setq getucs (getvar "ucsname"))
  (if  (= getucs "") (setq getucs "*Not Named*") ())
  (SETQ PEIL (GETPOINT (strcat "\nNamed UCS: " getucs "\nEnter or give point for elavation 0.0: ")))
  (command "ucs" PEIL "")
  (COMMAND "Redraw")
  (setq pt1 '(-10000000.0 0.0 0.0))
  (setq pt2 '(10000000.0 0.0 0.0))
  (grdraw pt1 pt2 6 1)

  
  (if (setq ss (ssget)) 
    (progn
      (setq n  0 )
      (while (< n (sslength ss))

        (setq e   (ssname ss n))
        (setq obj (vlax-ename->vla-object e))

        (if (And (= (vla-get-ObjectName    obj) "AcDbBlockReference")
                 (= (vla-get-HasAttributes obj) :vlax-true) )

          (if    (vl-position (vla-get-EffectiveName obj) glv:BlkName) (progn		; CAB, for block ..1 ..2



            (setq ObjID (vla-get-ObjectID       obj) 
                  ;;InsPt (vla-get-InsertionPoint obj)  ; CAB
                  InsPt (trans (vlax-get Obj 'InsertionPoint) (vlax-get Obj 'Normal) 1) ; OCS 2 UCS - CAB
		  ;;InsPt  (vlax-get Obj 'InsertionPoint)  ; lamh ook voor in z voor Z(Y1) Z(Y2) Z(Y3) 
            )

            ;(setq InsPt (vlax-safearray->list (vlax-variant-value Inspt)))  ; CAB
	    
            (if (= (vla-get-IsDynamicBlock obj) :vlax-true)
              (progn
             
             ;; properties
            
            (setq lstDynProp
              (vlax-safearray->list
                (vlax-variant-value (vla-GetDynamicBlockProperties obj))
              )
            )
            (foreach x lstDynProp
              (if (member (vla-get-PropertyName x) (list "Visibility"))
                (progn
                (setq DynID  (vla-get-PropertyName x))
                (setq DynVal (vlax-variant-value (vla-get-Value x)) )
              )) ; end progn, if
            ) ; end forEach

            (cond
              ((member DynVal (list "Y1" "Y2" "Y3" "Y4"
                                    "Y5" "Y6" "Y7" "Y8" ))
                (setq ValOfPt (nth 1 InsPt) PtIndex 2)  
              )
              ((member DynVal (list "Z1" "Z2" "Z3" "Z4" "Z(Y1)" "Z(Y2)" "Z(Y3)"))
                (setq ValOfPt (nth 2 InsPt) PtIndex 4)  
              )
     
	      ((member DynVal (list "Z(Y1)" "Z(Y2)" "Z(Y3)"))
	        (setq  InsPt  (vlax-get Obj 'InsertionPoint)); lamh ook voor in z voor Z(Y1) Z(Y2) Z(Y3)
                (setq ValOfPt (nth 2 InsPt) PtIndex 4)
	       )
	      
              (T (setq ValOfPt (nth 1 InsPt) PtIndex 2))
            ) ; end cond

          )) ; end progn, if DynamicBlock

         ;;  Test Mod by CAB
	    (princ ValOfPt)
	(setq ValOfPt (/ ValOfPt 1.000))
	;   (princ "")
	    (princ ValOfPt) 
	(setq ValOfPt (rtos ValOfPt 2 3))
	;   (princ "")
	    (princ ValOfPt)
	(setq ValOfPt (atof ValOfPt))
            (princ "")
	    (princ ValOfPt)	       
        ; (setq ValOfPt (atoi (rtos (/ ValOfPt 1000.) 2 3))) ; CAB rount to zero precision @ 0.49999 = 0

          ;;; Check Y-Value or Z-Value of point

          (setq str
            (cond
              ((> ValOfPt 0.0) "+"   )
              ((= ValOfPt 0.0) "%%P" )
              ((< ValOfPt 0.0) ""    )
              (T               ""    )
            )
          )

(setq NULPUNT '(0.0 0.0 0.0))	    
(grdraw NULPUNT InsPt 2 1)  ; lijntje trekken..  


          ;;; Define Praefix
;|  CAB removed
          (setq PrFix (strcat "%ps[" str ",]"))
          (setq YVal  (strcat "%<\\AcObjProp Object(%<\\_ObjId "
                              (vl-princ-to-string ObjID)
                              ">%).InsertionPoint>%"
          ))
          (setq FStr (strcat "%<\\AcExpr (" YVal "/" "1000" ") "
                             "\\f \"" "%lu2"
                             "%pt" (itoa PtIndex)
                             "%pr3" "%ds44" PrFix "\">%"
          ))
|;
	
(setq DZ (getvar "DIMZIN"))
(setvar "DIMZIN" 0)
(setq FStr  (strcat str (rtos ValOfPt 2 3)))
(setvar "DIMZIN" DZ)

          ;;; Get Attribut of Block

          (setq objAttList
            (vlax-safearray->list
              (vlax-variant-value (vla-GetAttributes obj)
            )
          ))

          (setq k 0 len (length objAttList) )

          (while (< k len )
            (if (= (vla-get-TagString (setq x (nth k objAttList)))
                   glv:BlkATAG )
             (setq objAttribut x  k len )
            )
            (setq k (1+ k))
          )

          (if objAttribut
            (progn

            (vla-put-TextString objAttribut FStr )
            (vla-update objAttribut )

             ;;; Update Field Value with command

            (SetVar "CmdEcho" 0)
            (VL-CmdF "_.UpdateField" e "")
            (SetVar "CmdEcho" 1)

          )) ;; end progn, if
        ) ; end if
      )) ; end progn, if BLOCK + Attribut

      (setq n (1+ n))

    ) ; end while
  )) ; end progn, if

  (princ)
;  (COMMAND "REGEN")
)
;;;-----------------------------------------------------------------------

(princ)

